$!Setup generator for SDH functions
$!Copyright (c) 1994,1995,1996 Glenn C. Everhart. All rights reserved.
$! Generates script to be run at startup time from the startup process.
$ask:==inquire
$emit:==write sys$output
$oldprv=f$setprv("cmkrnl,sysprv,log_io,phy_io,tmpmbx,volpro,detach")
$tprv=f$privilege("cmkrnl,sysprv,log_io,phy_io,tmpmbx,volpro,detach")
$if (tprv) then goto gotprv
$write sys$output "Not enough privileges."
$exit
$gotprv:
$vmldst=0
$emit "[H[J"
$if (f$search("sys$system:JTdriver.exe") .nes. "") then goto seedrvr
$emit "%SDH-F-Cannot find driver. Exiting."
$ exit
$seedrvr:
$goto tstdo
$nocomp:
$emit "Component missing. Exiting."
$emit "Be sure all the component pieces exist in sys$system."
$exit
$tstdo:
$! Be sure all needed files exist in system area
$if f$trnlnm("gcy$sys") .eqs. ""
$ then
$ ask gcss "Please give dev:[dir] used for SDH programs"
$ if gcss .nes. "" then ass/sys 'gcss' gcy$sys
$ endif
$if f$trnlnm("gcy$sys") .eqs. "" then goto dtsts
$if f$search("gcy$sys:JTdmn.cld") .eqs. "" then goto nocomp
$if f$search("gcy$sys:JTAuthMaint.exe") .eqs. "" then goto nocomp
$if f$search("gcy$sys:JTdmn.exe") .eqs. "" then goto nocomp
$JTau*thmaint:==$gcy$sys:JTauthmaint
$set comm sys$system:zmenu
$ vmldst=0
$ fswpo="*"
$ strswpop="SWAP"
$ flnko=" "
$ frlko=" "
$zmlc=1
$mdomnu:
$zmenu/POINTER="[1;7m-->[m"/SYMBOLS/initial='zmlc'
   #6[1;7mSDH CONTROL/MAINTENANCE[m  00:00:00

      ^ 'fswpo'Select "Shelving" style Hierarchical Storage
      ^ 'frlko'Select "readonly softlink" style Hierarchical Storage
      ^ 'flnko'Select "softlink" style Hierarchical Storage
      ^  Explain hierarchical storage styles
      ^  Proceed to set up SDH configuration file
      ^  Unshelve all files on a disk if space exists (assumes SDH is running)
      ^  Stop a running SDH server cleanly
      ^  Start a server that is already configured
      ^  Quit, do nothing
$!
$!zmlc = choice
$ if choice .eq. 9 then exit
$ if choice .eq. 1
$ then
$ strswpop="SWAP"
$ fswpo="*"
$ flnko=" "
$ frlko=" "
$ goto mdomnu
$ endif
$ if choice .eq. 2
$ then
$ strswpop="LINK"
$ fswpo=" "
$ flnko=" "
$ frlko="*"
$ goto mdomnu
$ endif
$ if choice .eq. 3
$ then
$ strswpop="RLNK"
$ fswpo=" "
$ flnko="*"
$ frlko=" "
$ goto mdomnu
$ endif
$ if choice .eq. 4
$ then
$ copy sys$input sys$output
  There are 3 types of SDH hierarchical storage.
   in SHELVING style, a file is copied to nearline storage and truncated
        to zero blocks on the main disk. When the file is opened, it is
        copied from nearline disk back to its original site and erased
        from nearline storage. Thus it is automatically retrieved when
        accessed.
   in SOFTLINK style, the file is copied to nearline storage and any 
        opens afterwards access the file directly on nearline storage.
        The original file is truncated to zero blocks and kept as a
        pointer so that the file acts as if still on main disk.
   in READONLY SOFTLINK style, the file is copied to nearline storage. If
        it is opened for read only, it is accessed on the nearline storage
        and left there. If it is opened for any kind of write or update
        access, it is treated as shelved and unshelved automatically.

   Softlinks require that files be kept on disk type storage, using
   anything that acts like a disk to VMS. Note too that if using the
   READONLY SOFTLINK style, if someone opens a file for read, and someone
   else opens it for update and updates it after, the first accessor
   will not see the updates. Since the file will be deleted after inswap
   (takes effect once it is closed by all readers), LATER readers will
   however see the updates since the file will be on normal disk.
$eod
$ ask xjnkkk "Enter return to continue>"
$ goto mdomnu
$ endif
$if choice .eq. 6
$ then
$! unshelve all
$ ask udevice "What device should have all files unshelved from it"
$ if udevice .eqs. "" then goto mdomenu
$ JTa_summlen = "99999999999"
$ JTauthmaint 'udevice'[000000]corimg.sys\%PURGE
$ JTauthmaint 'udevice'[000000]corimg.sys\%SUMM
$ if f$integer(JTa_summlen) .ge. f$getdvi(udevice,"freeblocks")
$ then
$ emit "%SDH-F-NoRoom Not enough room on device to unshelve everything"
$ emit " You must delete some files to make room to unshelve all files."
$ emit " Total size of shelved files is",JTa_summlen
$ wait 0:0:02
$ goto mdomnu
$ endif
$ ! JTa_summfile is the filename of summary file
$ open/read JTmf 'JTa_summfile'
$ fillin=" "
$ read/end=cJTmf JTmf fillin
$ sJTmf:
$ fillin=f$extract(0,f$locate("(",fillin)-1,fillin)
$ fillin = f$edit(fillin,"upcase,collapse")
$ ! force inswap
$! Following operation does so with minimal overhead, forcing reading.
$ copy 'fillin' nla0:
$ goto sJTmf
$ cJTmf:
$ close JTmf
$ delete 'f$search(JTa_summfile)'
$ goto mdomnu
$ endif
$if choice .eq. 7
$ then
$ emit "Please select FIRST device controlled by an SDH server"
$ emit "The following commands contain the disks eligible:"
$ search/nohead/match=and sys$manager:JTm_d*.daemon hsa,deas
$ ask udevice "What device should have its SDH server stopped"
$ if udevice .eqs. "" then goto mdomenu
$ desdvc="Gv" + udevice - ":" - "_" - "_"
$ desdvc = f$edit(desdvc,"upcase,collapse")
$ uctxt=""
$ prclc3:
$ uxpid=f$pid(uctxt)
$ if uxpid .eqs. ""
$ then
$ emit "%SDH-W-Cannot find server. Specify the FIRST device which the"
$ emit "  SDH server controls, please."
$ goto mdomnu
$ endif
$ prcnam=f$getjpi(uxpid,"prcnam")
$ forcex :==$gcy$sys:forcex
$ if f$edit(prcnam,"upcase,collapse") .eqs. desdvc
$ then
$ forcex 'uxpid'
$! Now clean up any outstanding assigns that use the same JTAn unit.
$! Rely on our having put the JTdmn/deas in for the main one...
$ fillin = " "
$ open/read strx sys$manager:SDH_Startup.com
$v2strx:
$ read/end=v1strx strx fillin
$ if f$locate(udevice,fillin) .ge. f$length(fillin) then goto v2strx
$! we found a line containing desired device.
$! now find JTAnnn: string and isolate it.
$ close strx
$ fillin=f$edit(fillin,"upcase")
$ lJTa=f$locate("JTA",fillin)
$ fillin=f$extract(lJTa,f$length(fillin),fillin)
$ fillin = f$extract(0,f$locate(":",fillin),fillin)
$ JTanam="/SHARE:"+fillin
$JTdmn:==$gcy$sys:JTdmn
$ open/read strx sys$manager:SDH_Startup.com
$ v3strx:
$ read/end=v1strx strx fillin
$ if f$locate(JTanam,fillin) .ge. f$length(fillin) then goto v3strx
$ got one of the share lines. add /deas
$ fillin = fillin - JTanam
$ fillin = "$JTdmn/deas"+f$extract(6,f$length(fillin),fillin)
$ 'fillin'
$ goto v3strx
$v1strx:
$ close strx
$ goto mdomnu
$ endif
$ goto prclc3
$ !
$ endif
$if choice .eq. 8
$ then
$! SDH startup won't start already active JT device daemons and the
$! /share ones should be ok to run twice.
$ @sys$manager:SDH_Startup
$ exit
$ endif
$JTnum=0
$dtsts:
$if f$search("sys$manager:SDH_Startup.com") .eqs. "" then goto gocfg
$emit "SYS$MANAGER:SDH_Startup.COM already exists. Delete if you wish"
$emit "to create a new one with this procedure."
$ask ovrd "Continue anyway, adding new server[Y/N][N]"
$if f$extract(0,1,f$edit(ovrd,"collapse,upcase")) .eqs. "Y" then goto gocfg
$exit
$gocfg:
$fmk="/fcnmsk:70547"
$fJTddb=" "
$sJTddb=" "
$fJTsys=" "
$sJTsys=" "
$if f$trnlnm("gcy$sys") .nes. ""
$then
$fJTsys="*"
$sJTsys=f$trnlnm("gcy$sys")
$endif
$if f$trnlnm("JTd$db") .nes. ""
$then
$fJTddb="*"
$sJTddb=f$trnlnm("JTd$db")
$endif
$ndsk=0
$noutarea=0
$ndskst=ndsk
$fdelsav=" "
$sdelsav=""
$if f$trnln("delsav") .nes. ""
$then
$fdelsav="*"
$sdelsav=f$trnlnm("delsav")
$endif
$imgf=0
$zmlc=1
$if fdelsav .nes. " " .and. fJTddb .nes. " " .and. fJTsys .nes. " " then zmlc=4
$domnu:
$zmenu/POINTER="[1;7m-->[m"/SYMBOLS/initial='zmlc'
    #6[1;7mSDH GLOBAL SETUP[m  00:00:00

     ^ 'fJTddb'Set area to hold SDH database files
     ^  Set start intercept driver unit number (now 'ndsk')
     ^ 'fJTsys'Set area for SDH executable images
     ^  Done this menu, process disk selection
     ^  Remove a disk from SDH startup configuration
     ^  Set images which are exempt from SDH (e.g. defraggers)
     ^ 'fdelsav'Set area for storing nearline files shelved
     ^  Quit, do nothing


$if choice .eq. 8
$ then
$! close cfg
$ exit
$ endif
$zmlc=choice
$if choice .eq. 6
$ then
$ if fJTsys .nes. "*"
$ then
$ emit "%SDH-E- Must define executable area first"
$ goto domnu
$ endif
$copy sys$input sys$output

   In the following, please enter images that will be EXEMPT from SDH
   access checks. That is, these images will be free to open files as
   they like; access TO these images can be checked. The list should
   include defragmenters and similar utilities you have. You can use
   wildcards (e.g. *BACKUP.EXE*) to shorten strings, but BE CAREFUL
   with these. A wildcard path CAN BE SPOOFED. If you include the
   FULL device:[directoru]file.ext;version path, you can be sure the
   image granted access is the one you want. Note the list is global
   to the whole system and can have at most 32 items. The file is in
   GCY$SYS:EXEMPT.IMAGES if you wish to edit it. This selection will
   merely add lines to the file.
  
$!
$ ask qedit "Edit exempt images list instead of append here? [Y/N][N]
$ if f$extract(0,1,f$edit(qedit,"collapse,upcase")) .eqs. "Y"
$ then
$ ass/user sys$command sys$input
$ edit gcy$sys:exempt.images
$ goto domnu
$ endif
$ if f$search("gcy$sys:exempt.images") .eqs. ""
$ then
$ open/write xim gcy$sys:exempt.images
$ imgf=1
$gim1:
$ ask imst "Image path string"
$ if imst .eqs. ""
$ then
$ close xim
$ goto domnu
$ endif
$ write xim imst
$ goto gim1
$ else
$ imgf=1
$ open/append xim gcy$sys:exempt.images
$gim2:
$ ask imst "Image path string"
$ if imst .eqs. ""
$ then
$ close xim
$ goto domnu
$ endif
$ write xim imst
$ goto gim2
$ endif
$ goto domnu
$endif
$if choice .eq. 4 then goto bldcfg
$if choice .eq. 2
$ then
$ ask dstrt "Enter start unit number for intercept"
$ if dstrt .eqs. "" then goto domnu
$ ndsk=f$integer(dstrt)
$ ndskst=ndsk
$ goto domnu
$ endif
$if choice .eq. 5
$ then
$ if f$search("sys$manager:SDH_Startup.com") .eqs. ""
$ then
$ emit "%SDH-W-no previous configuration exists."
$ goto domnu
$ endif
$ emit " **** BEWARE *** "
$ emit " Don't remove disks if you have files shelved on them already."
$ emit " Instead run the separate unshelve script first to unshelve files"
$ emit " on the disk, THEN change the configuration."
$ emit "Current configuration:"
$ search/nohigh sys$manager:SDH_Startup.com "$JTdmn"
$ emit ""
$ ask drmv "Enter disk name to remove, NONE for none"
$ if drmv .eqs. "" .or. drmv .eqs. "NONE" then goto domnu
$ text = " "
$ open/read JTi sys$manager:SDH_Startup.com
$ open/write JTo sys$manager:SDH_Startup.com
$rlpu:
$ read/end=clsm JTi text
$ ltxt=f$length(text)
$ if f$locate(drmv,text) .ge. ltxt then write JTo text
$ goto rlpu
$clsm:
$ close JTo
$ close JTi
$ goto domnu
$ endif
$if choice .eq. 7
$ then
$ vmldst=0
$! goto wundst ! *********** patch out multiple dests for v1 **********
$ emit "If multiple destinations are desired they will be selected after"
$ emit "disks being selected as source disks for this server are selected."
$ emit "(Best not to select this however)"
$ ask mdest "Should multiple disk areas be used for shelved files[Y/N][Y]"
$if f$extract(0,1,f$edit(mdest,"collapse,upcase")) .nes. "Y" then goto wundst
$! multiple destinations
$ vmldst = 1
$ copy gcy$sys:JTfilsavmdsk.com gcy$sys:filsav.com
$ copy gcy$sys:JTfilrstmdsk.com gcy$sys:filrst.com
$ pur gcy$sys:fil*.com
$ goto domnu
$wundst:
$ ask idsv "Give area to place shelved files"
$ if idsv .nes. ""
$ then
$ on error then goto dsfu
$ open/write dsvt 'idsv'test.junk
$ write dsvt "test"
$ close dsvt
$ delete 'idsv'test.junk.
$ sdelsav=idsv
$ fdelsav="*"
$ copy gcy$sys:JTfilsav.com gcy$sys:filsav.com
$ copy gcy$sys:JTfilrst.com gcy$sys:filrst.com
$ goto domnu
$dsfu:
$emit "%SDH-W-Nodir - cannot write to this area. Ignored,"
$wait 0:0:05
$on error then continue
$ endif
$ goto domnu
$ endif
$if choice .eq. 1
$then
$ask iarea "Give area for database files (dvc:dir)"
$if iarea .eqs. "" then goto domnu
$!check if it exists by trying to put a file there
$open/write tmp 'iarea'tfil.tmp
$close tmp
$ttt=iarea+"tfil.tmp"
$if f$search(ttt) .nes. ""
$then
$del 'ttt'.
$fJTddb="*"
$sJTddb=iarea
$goto domnu
$endif
$emit "%SDH-E-Area does not exist or cannot be written."
$wait 0:0:06
$goto domnu
$endif
$if choice .eq. 3
$then
$ask iarea "Give area for executable files (dvc:dir)"
$if iarea .eqs. "" then goto domnu
$!check if it exists by trying to put a file there
$open/write tmp 'iarea'tfil.tmp
$close tmp
$ttt=iarea+"tfil.tmp"
$if f$search(ttt) .nes. ""
$then
$del 'ttt'.
$fJTsys="*"
$sJTsys=iarea
$goto domnu
$endif
$emit "%SDH-E-Area does not exist or cannot be written."
$wait 0:0:06
$goto domnu
$endif
$bldcfg:
$if fJTddb .nes. "*"
$then
$emit "SDH-F-Must define database location before disk select"
$goto domnu
$endif
$write sys$output "%SDH-I-Working..."
$if f$search("sys$manager:SDH_Startup.com") .eqs. ""
$then
$open/write cfg sys$manager:SDH_Startup.com
$else
$open/append cfg sys$manager:SDH_Startup.com
$endif
$write cfg "$sysgen:==$sysgen"
$write cfg "$sysman:==$sysman"
$if f$getsyi("CPU").ge. 128 then write cfg "$sysgen:==mc sysman io"
$ttt="$assign/sys/exec "+sJTddb+" JTd$JT"
$write cfg ttt
$ttt="assign/sys/exec "+sJTddb+" JTd$JT"
$'ttt'
$write cfg "$ass/sys ""Y"" gcy$delsav"
$write cfg "$define jtdel$mode 0"
$ass/sys "Y" gcy$delsav
$ttt="$assign/sys/exec "+sJTddb+" JTd$db"
$write cfg ttt
$ttt="assign/sys/exec "+sJTddb+" JTd$db"
$'ttt'
$ttt="$assign/sys/exec "+sJTddb+" gcy$cm"
$write cfg ttt
$ttt="assign/sys/exec "+sJTddb+" gcy$cm"
$'ttt'
$ttt="$assign/sys/exec "+sJTddb+" gce$delseq"
$write cfg ttt
$ttt="$assign/sys/exec "+sJTddb+" gce$delseq"
$'ttt'
$ttt="$assign/sys/exec "+sJTsys+" gcy$sys"
$write cfg ttt
$ttt="assign/sys/exec "+sJTsys+" gcy$sys"
$'ttt'
$write cfg "$set command gcy$sys:JTdmn"
$if sdelsav .nes. ""
$then
$ttt="$assign/sys "+sdelsav+" delsav"
$write cfg ttt
$ttt="assign/sys "+sdelsav+" delsav"
$'ttt'
$ttt="$assign/job "+sdelsav+" delsav"
$write cfg ttt
$ttt="assign/job "+sdelsav+" delsav"
$'ttt'
$! set default gcy$scratch too if none
$if f$trnlnm("gcy$scratch") .eqs. ""
$ then
$write cfg "$if f$trnlnm(""gcy$scratch"").eqs. """" "
$write cfg "$then"
$ttt="$assign/sys "+sdelsav+" gcy$scratch"
$write cfg ttt
$ttt="assign/sys "+sdelsav+" gcy$scratch"
$'ttt'
$ttt="$assign/job "+sdelsav+" gcy$scratch"
$write cfg ttt
$ttt="assign/job "+sdelsav+" gcy$scratch"
$'ttt'
$write cfg "$endif"
$endif
$endif
$! .com files to move files etc. are found in gcy$cm but installed into
$! gcy$sys. Copy them if need be.
$if f$trnlnm("gcy$sys") .nes. f$trnlnm("gcy$cm") then copy gcy$sys:*.com gcy$cm:
$write cfg "$JTau*thmaint:==$gcy$sys:JTauthmaint"
$JTau*thmaint:==$gcy$sys:JTauthmaint
$write cfg "$JTdolog:==$gcy$sys:JTdolog"
$!gosub gen_dsk_syms
$gen_dsk_syms:
$! generate symbols dv1 to dv150, mounted disks first
$! with disk names of disks on the system.
$! Fills these in with (no more disks...) message if none
$n=0
$SL1:
$n = n+1
$dv'n' = "(No more disks on system)"
$dp'n'=" "
$if n .lt. 150 then goto SL1
$n=0
$sl2:
$ n = n+1
$xsl2:
$ dnm=f$device("*","DISK")
$ if dnm .eqs. "" then goto sl3
$ if f$getdvi(dnm,"MNT") .nes. "TRUE" .and. dnm .nes. "" then goto xsl2
$! *********** V1 - omit system disks from consideration ***********
$! *********** Next 2 lines throw out mounted system disks**********
$ dnmsyst=dnm+"[000000]VMS$COMMON.DIR"
$ if f$search(dnmsyst) .nes. "" then goto xsl2
$ dv'n' = dnm
$ssl2:
$ if n .lt. 150 then goto sl2
$sl3:
$n = n - 1
$tsl2:
$ n = n+1
$xtsl2:
$ dnm=f$device("*","DISK")
$ if dnm .eqs. "" then goto tsl3
$ if f$getdvi(dnm,"MNT") .eqs. "TRUE" .and. dnm .nes. "" then goto xtsl2
$ dv'n' = dnm
$tssl2:
$ if n .lt. 150 then goto tsl2
$tsl3:
$hiJT=n
$!return
$!set comm gcy$sys:zmenu
$if f$search("sys$scratch:JTM_dsks.mnuscr") .nes. "" then del sys$scratch:JTM_dsks.mnuscr.
$copy sys$input sys$scratch:JTM_dsks.mnuscr
 #6[1;7mSDH Configuration[m
         (Non System) Disk Selection
    Use arrows to move to selection. Use RETURN to select.

^ End disk selection
^ 'dv1' 'dp1'
^ 'dv2' 'dp2'
^ 'dv3' 'dp3'
^ 'dv4' 'dp4'
^ 'dv5' 'dp5'
^ 'dv6' 'dp6'
^ 'dv7' 'dp7'
^ 'dv8' 'dp8'
^ 'dv9' 'dp9'
^ 'dv10' 'dp10'
^ 'dv11' 'dp11'
^ 'dv12' 'dp12'
^ 'dv13' 'dp13'
^ 'dv14' 'dp14'
^ 'dv15' 'dp15'
^ 'dv16' 'dp16'
^ 'dv17' 'dp17'
^ 'dv18' 'dp18'
^ 'dv19' 'dp19'
^ 'dv20' 'dp20'
^ 'dv21' 'dp21'
^ 'dv22' 'dp22'
^ 'dv23' 'dp23'
^ 'dv24' 'dp24'
^ 'dv25' 'dp25'
^ 'dv26' 'dp26'
^ 'dv27' 'dp27'
^ 'dv28' 'dp28'
^ 'dv29' 'dp29'
^ 'dv30' 'dp30'
^ 'dv31' 'dp31'
^ 'dv32' 'dp32'
^ 'dv33' 'dp33'
^ 'dv34' 'dp34'
^ 'dv35' 'dp35'
^ 'dv36' 'dp36'
^ 'dv37' 'dp37'
^ 'dv38' 'dp38'
^ 'dv39' 'dp39'
^ 'dv40' 'dp40'
^ 'dv41' 'dp41'
^ 'dv42' 'dp42'
^ 'dv43' 'dp43'
^ 'dv44' 'dp44'
^ 'dv45' 'dp45'
^ 'dv46' 'dp46'
^ 'dv47' 'dp47'
^ 'dv48' 'dp48'
^ 'dv49' 'dp49'
^ 'dv50' 'dp50'
^ 'dv51' 'dp51'
^ 'dv52' 'dp52'
^ 'dv53' 'dp53'
^ 'dv54' 'dp54'
^ 'dv55' 'dp55'
^ 'dv56' 'dp56'
^ 'dv57' 'dp57'
^ 'dv58' 'dp58'
^ 'dv59' 'dp59'
^ 'dv60' 'dp60'
^ 'dv61' 'dp61'
^ 'dv62' 'dp62'
^ 'dv63' 'dp63'
^ 'dv64' 'dp64'
^ 'dv65' 'dp65'
^ 'dv66' 'dp66'
^ 'dv67' 'dp67'
^ 'dv68' 'dp68'
^ 'dv69' 'dp69'
^ 'dv70' 'dp70'
^ 'dv71' 'dp71'
^ 'dv72' 'dp72'
^ 'dv73' 'dp73'
^ 'dv74' 'dp74'
^ 'dv75' 'dp75'
^ 'dv76' 'dp76'
^ 'dv77' 'dp77'
^ 'dv78' 'dp78'
^ 'dv79' 'dp79'
^ 'dv80' 'dp80'
^ 'dv81' 'dp81'
^ 'dv82' 'dp82'
^ 'dv83' 'dp83'
^ 'dv84' 'dp84'
^ 'dv85' 'dp85'
^ 'dv86' 'dp86'
^ 'dv87' 'dp87'
^ 'dv88' 'dp88'
^ 'dv89' 'dp89'
^ 'dv90' 'dp90'
^ 'dv91' 'dp91'
^ 'dv92' 'dp92'
^ 'dv93' 'dp93'
^ 'dv94' 'dp94'
^ 'dv95' 'dp95'
^ 'dv96' 'dp96'
^ 'dv97' 'dp97'
^ 'dv98' 'dp98'
^ 'dv99' 'dp99'
^ 'dv100' 'dp100'
^ 'dv101' 'dp101'
^ 'dv102' 'dp102'
^ 'dv103' 'dp103'
^ 'dv104' 'dp104'
^ 'dv105' 'dp105'
^ 'dv106' 'dp106'
^ 'dv107' 'dp107'
^ 'dv108' 'dp108'
^ 'dv109' 'dp109'
^ 'dv110' 'dp110'
^ 'dv111' 'dp111'
^ 'dv112' 'dp112'
^ 'dv113' 'dp113'
^ 'dv114' 'dp114'
^ 'dv115' 'dp115'
^ 'dv116' 'dp116'
^ 'dv117' 'dp117'
^ 'dv118' 'dp118'
^ 'dv119' 'dp119'
^ 'dv120' 'dp120'
^ 'dv121' 'dp121'
^ 'dv122' 'dp122'
^ 'dv123' 'dp123'
^ 'dv124' 'dp124'
^ 'dv125' 'dp125'
^ 'dv126' 'dp126'
^ 'dv127' 'dp127'
^ 'dv128' 'dp128'
^ 'dv129' 'dp129'
^ 'dv130' 'dp130'
^ 'dv131' 'dp131'
^ 'dv132' 'dp132'
^ 'dv133' 'dp133'
^ 'dv134' 'dp134'
^ 'dv135' 'dp135'
^ 'dv136' 'dp136'
^ 'dv137' 'dp137'
^ 'dv138' 'dp138'
^ 'dv139' 'dp139'
^ 'dv140' 'dp140'
^ 'dv141' 'dp141'
^ 'dv142' 'dp142'
^ 'dv143' 'dp143'
^ 'dv144' 'dp144'
^ 'dv145' 'dp145'
^ 'dv146' 'dp146'
^ 'dv147' 'dp147'
^ 'dv148' 'dp148'
^ 'dv149' 'dp149'
^ 'dv150' 'dp150'
^ Other disk (where the system has more than fit in the menu)
$eod
$!
$getdsk:
$zmenu/scroll/symbols sys$scratch:JTM_dsks.mnuscr
$ choice = choice -1
$ if choice .eq. 0 then goto wrapup
$ if choice .eq. 151
$ then
$ ask dsk "Give disk name"
$ if dsk .eqs. "" then goto getdsk
$ if f$getdvi(dsk,"MNT") .nes. "TRUE" then goto getdsk
$ goto intac
$ endif
$ chcn=f$integer(choice)
$ dp'chcn' = "*"
$ dsk = dv'chcn'
$if dsk .eqs. "" then goto wrapup
$goto intac
$wildsk:
$wild=1
$dsk=f$device(,"DISK")
$if dsk .eqs. "" then goto wrapup
$if f$getdvi(dsk,"MNT") .nes. "TRUE" then goto wildsk
$intac:
$JTnm="JTA"+f$string(ndsk)+":"
$ccmd="$sysgen connect "+JTnm+"/noada/driver=JTdriver"
$if ndsk.eq.ndskst .and. f$getsyi("CPU") .ge. 128
$then
$ccmd=ccmd-"JTdriver" + "sys$system:JTdriver"
$endif
$skfg=" "
$fdfl=" "
$fidsw=""
$kmon=" "
$aufm=" "
$gndb=" "
$kmal=" "
$kstr=""
$fcnvl=65921
$zmlc=7
$ if strswpop .nes. "SWAP"
$ then
$ ask qedit "Is this disk only a nearline disk destination [Y/N][N]"
$if f$extract(0,1,f$edit(qedit,"upcase,collapse")) .eqs. "Y"
$ then
$fcnvl =65792
$ endif
$ endif
$goto xkyz ! ****************** v1 patch out these options *********
$ ask qedit "Do you wish to use optional performance parameters [Y/N][N]"
$if f$extract(0,1,f$edit(qedit,"upcase,collapse")) .nes. "Y" then goto xkyz
$fvmnu:
$zmenu/POINTER="[1;7m-->[m"/SYMBOLS/initial='zmlc'
  #6[1;7mSDH DISK SETUP - Special Options[m

  Note: These options are used for some performance tuning
  which is not required but may be selected if you wish to
  tune the system for minimum overhead at runtime at the
  expense of overhead at startup.

    ^ 'fdfl' Enter file of file IDs to load for kernel marking
    ^ 'kmon' Examine only kernel-marked files for access tests
    ^ 'aufm' Set to automatically kernel-mark all files on load
              (This requires generating the file list at boot)
    ^ 'gndb' Generate filelist database and set to use it
    ^ 'kmal' Act as if ALL files were kernel-marked (use if most are)
    ^   Quit, do nothing.
    ^   Done this menu
$zmlc=choice
$if choice .eq. 6
$ then
$  close cfg
$  goto lastexit
$ endif
$if choice .eq. 1
$then
$fidsw = " "
$fidfl=" "
$ask fidfl "Enter file of file IDs to load (<cr> if none)"
$if fidfl .nes. "" .and. f$search(fidfl) .nes. ""
$ then
$ fidsw = "/FILENUM:"+FIDFL
$ fdfl="*"
$ endif
$goto fvmnu
$endif
$if choice .eq. 2
$then
$if kmon .eqs. " "
$ then
$ fcnvl=328129
$ kmon="*"
$ kmal=" "
$ goto fvmnu
$ endif
$if kmon .eqs. "*"
$ then
$ fcnvl=70547
$ kmon=" "
$ goto fvmnu
$ endif
$endif
$if choice .eq. 3
$ then
$! Use corimg.sys, a useless file that's on all VMS volumes.
$! We don't actually touch it here, but if we did it would do no harm.
$ JTa_listfile=""
$ JTauthmaint 'dsk'[0000000]corimg.sys\%LIST
$ fidfl=f$edit(JTa_listfile,"trim,collapse,upcase")
$ if fidfl .nes. "" then fidsw="/FILENUM:"+FIDFL
$ aufm="*"
$ goto fvmnu
$endif
$if choice .eq. 4
$ then
$ JTa_listfile=""
$ JTauthmaint 'dsk'[0000000]corimg.sys\%LIST
$ fidfl=f$edit(JTa_listfile,"trim,collapse,upcase")
$ if fidfl .nes. "" then fidsw="/FILENUM:"+FIDFL
$ gndb="*"
$ goto fvmnu
$endif
$if choice .eq. 5
$ then
$ kmal="*"
$ fcnvl=103315
$ kmon=" "
$ goto fvmnu
$endif
$if choice .eq. 7 then goto xkyz
$xkyz:
$ if vmldst .ne. 0
$ then
$! enter multiple destinations now
$ if ndsk .eq. ndskst
$ then
$! This is the first disk of the bunch, so we can form our logicals here.
$strdsk = " "
$strdsk = dsk - ":"
$ choice=1
$ zactch=" "
$zdpchx:
$ chcn=f$integer(choice)
$ zactch = dp'chcn'
$ dp'chcn' = " "
$ if zactch .eqs. "*" then dp'chcn' = "I"
$ choice = choice + 1
$ if choice .le. 150 then goto zdpchx
$ mychcn=0
$godsks:
$emit "Please select output disks"
$wait 0:0:03
$zmenu/scroll/symbols sys$scratch:JTM_dsks.mnuscr
$ choice = choice -1
$ if choice .eq. 0 then goto dunitso
$ chcn=f$integer(choice)
$ dp'chcn' = "O"
$ odsk = dv'chcn'
$if odsk .eqs. "" then goto dunitso
$if f$getdvi(odsk,"MNT") .nes. "TRUE"
$ then
$ emit "%SDH-W-Notmounted Output disk must be mounted to select"
$ goto godsks
$ endif
$! got a disk now...
$ ask idsv "Give directory to place shelved files"
$ if idsv .nes. ""
$ then
$ on error then goto godsks2
$ open/write dsvt 'odsk''idsv'test.junk
$ write dsvt "test"
$ close dsvt
$ delete 'idsv'test.junk.
$ mychcn = mychcn + 1
$ if mychcn .eq. 1
$ then
$ sdelsav=odsk+idsv
$ fdelsav="*"
$ddmnm="sys$manager:JTM_o"+f$string(ndskst)+".oenv"
$open/write d00d 'ddmnm'
$ endif
$! Need assign to device
$ ndvc=dsk - ":"
$ mynum=" "
$ mynum=f$fao("!ZW",mychcn)
$ mytst="GH"+ndvc+"GDX"+mynum
$ ddddd="$ass/job "+odsk+idsv+" "+mytst
$ write d00d ddddd
$ goto dunitso
$godsks2:
$ emit "%SDH-F-Cannot write to directory given"
$ wait 0:0:03
$ goto godsks
$dunitso:
$ close d00d
$ endif
$ endif
$ endif
$strdsk = " "
$strdsk = dsk - ":"
$strdsk = "JTD$" + strdsk
$xcmd="$if f$device(""*JTA"+f$string(ndsk)+"*"") .nes. """" then goto xldJT"
$write cfg xcmd
$write cfg ccmd
$write cfg "$xldJT:"
$write sys$output " "
$write sys$output " ... working ..."
$CCMD="$JTdmn/fcnmsk:"+f$string(fcnvl)+kstr
$if ndsk .gt. ndskst then ccmd=ccmd+"/SHARE:JTA"+f$string(ndskst)+":"
$if fidsw .nes. " " then ccmd=ccmd+fidsw
$! Pull in globally exempt images if a listfile exists for them.
$if f$search("gcy$sys:exempt.images") .nes. "" then ccmd=ccmd+"/exempt:gcy$sys:exempt.images"
$ccmd=ccmd+" "+JTnm+" "+dsk
$if ndsk .eq. ndskst
$then
$ddmnm="sys$manager:JTM_d"+f$string(ndskst)+".daemon"
$open/write d0d 'ddmnm'
$write d0d "$set comm gcy$sys:JTdmn"
$write d0d "$set proc/priv=all"
$xddmnm="sys$manager:JTM_o"+f$string(ndskst)+".oenv"
$write d0d "$define/job JTM$SWPOP ",strswpop
$write d0d "$if f$search("""+xddmnm+""") .nes. """""
$write d0d "$then"
$write d0d "$@"+xddmnm
$write d0d "$endif"
$! Create a new filelist from the master database every time if requested.
$if sdelsav .nes. ""
$ then
$ttt="$assign/job "+sdelsav+" delsav:"
$write d0d ttt
$ endif
$dddd="$set proc/name=Gv"+dsk - ":" - "_" - "_"
$write d0d dddd
$c00c="$JTauthmaint "+dsk+"[0000000]corimg.sys\%LIST"
$if aufm .eqs. "*" then write d0d c00c
$write d0d ccmd
$! Generate deassign cmd to finish clean exits.
$zzd0d="$JTdmn/deas "+JTnm+" "+dsk
$write d0d zzd0d
$write d0d "$logo"
$close d0d
$write cfg "$define/job JTM$SWPOP ",strswpop
$write cfg "$define/sys JTM$SWPOP ",strswpop
$write cfg "$rdyctr=0"
$! put the run/det inside a test that the JT device is initially offline
$! and don't run the daemon if it was online first instead.
$! Thus the script can be run more than once & not start extra daemons.
$! Specify most quotas etc. by hand here so weird system account quotas
$! don't mess this up at some sites.
$write cfg "$ if (f$getdvi(""JTA",f$string(ndskst),":"",""sts"") .and. 16) .eq. 0"
$write cfg "$ then"
$write cfg "$rdeau:==run/detach/buffer_limit=64000/enqueue_limit=60/io_direct=50/prio=4/io_buffered=50/file_limit=30"
$write cfg "$rdetsw:=='rdeau'/job_table_quo=1024/maximum_work=1500/page_file=15000/uic=[1,4]/subprocess_limit=10"
$write cfg "$rdetsw/input=",ddmnm,"/out=sys$manager:JTM_d0.log sys$system:loginout"
$! Arrange to let the daemon get started before other disks start using it.
$! Test for a bit to ensure daemon comes online. Give up after 1 minute.
$! (Note: preceding assumes decent memory, quotas for daemon.)
$write cfg "$wtlopp:"
$write cfg "$wait 0:0:15"
$write cfg "$rdyctr=rdyctr+1"
$write cfg "$ if (f$getdvi(""JTA",f$string(ndskst),":"",""sts"") .and. 16) .eq. 0"
$write cfg "$ then"
$write cfg "$ if rdyctr .lt. 5 then goto wtlopp"
$write cfg "$ endif"
$write cfg "$ if (f$getdvi(""JTA",f$string(ndskst),":"",""sts"") .and. 16) .eq. 0"
$write cfg "$ then"
$write cfg "$ write sys$output ""%SDH-F-daemon failed to start properly"""
$write cfg "$ exit 2"
$write cfg "$ endif"
$write cfg "$ endif"
$endif
$if ndsk .gt. ndskst then write cfg ccmd
$ndsk=ndsk+1
$goto getdsk
$wrapup:
$close cfg
$open/write cfg sys$manager:JTm_login.com
$write cfg "$moveJTm:==@sys$manager:JT_sel_move"
$write cfg "$movefile:==@sys$manager:JTmove_files"
$write cfg "$JTauthmaint:==$gcy$sys:JTauthmaint"
$close cfg
$ write sys$output -
"M<>[?4l[?8h[m",-
"(B)07[?6l[r8"
$emit "Add the line"
$emit "  "
$EMIT "          $@SYS$MANAGER:SDH_STARTUP.COM"
$emit "  "
$emit "   to your SYSTARTUP_V5.COM file now. The script can be run from"
$emit "   a fully privileged account now if you wish."
$emit " "
$emit "Add the line"
$emit " "
$emit "		$@SYS$MANAGER:SDH_LOGIN.COM"
$emit " "
$EMIT "   to your SYLOGIN.COM file also to define symbols needed for SDH"
$emit " "
$exit
$lastexit:
$exit
