$ ! Close all [potentially] open files.
$ !
$ WS := WRITE SYS$OUTPUT
$ CLOSE /NOLOG KIT_DATA
$ !
$ ! Take care of interrupts
$ !
$ ON CONTROL_Y THEN GOTO CLEANUP_AND_EXIT_CONTROL_Y
$ !
$ ! Dispatch to error processing.
$ !
$ ON WARNING THEN GOTO CLEANUP_AND_EXIT_WITH_STATUS
$ !
$ ! Determine the course of action.
$ !
$ IF P1 .EQS. "VMI$_INSTALL" THEN GOTO INSTALL
$ IF P1 .EQS. "VMI$_IVP" THEN GOTO IVP
$ IF F$EXTRACT(0,5,P1) .EQS. "HELP_" THEN GOTO 'P1'
$ EXIT VMI$_UNSUPPORTED
$ !
$ ! Install the product.
$ !
$INSTALL:
$
$ IVP = FALSE
$ VMI$CALLBACK CHECK_VMS_VERSION -
	GCY$VERSION "054"
$ MODIFY_STARTUP_DB_AVAILABLE = GCY$VERSION
$ REQUIRED_SPACE = 8000
$ SAFETY_SPACE = 1400
$ VERSION = "050"
$ WD = "IF VMI$DEBUG THEN WRITE SYS$OUTPUT"
$
$ VMI$CALLBACK CHECK_VMS_VERSION -
	GCY$VERSION "''VERSION'"
$ IF GCY$VERSION THEN GOTO VERSION_OK
$ !
$ ! Indicate wrong version and exit
$ !
$WRONG_VERSION:
$
$ VMI$CALLBACK MESSAGE -
	E VERSION -
	"This kit must be installed on an existing VMS''VERSION' system."
$ GOTO CLEANUP_AND_EXIT_WITH_FAILURE
$
$VERSION_OK:
$
$ !
$ ! Check for disk space, exit if not enough.
$ !
$ VMI$CALLBACK CHECK_NET_UTILIZATION -
	GCY$SPACE 'REQUIRED_SPACE'
$ IF .NOT. GCY$SPACE THEN GOTO CLEANUP_AND_EXIT_WITH_FAILURE
$ !
$ ! Validate all sysgen parameters.
$ !
$ !
$ ! Set up for a conditional safe installation.
$ !
$ VMI$CALLBACK SET -
	SAFETY CONDITIONAL 'SAFETY_SPACE'
$ !
$ ! Restore secondary save sets, if any.
$ !
$RESTORE_SECONDARY_SAVESET:
$
$ !
$ ! Check for purging and IVP.
$ !
$ VMI$CALLBACK SET -
	PURGE ASK
$ IF IVP THEN VMI$CALLBACK SET IVP ASK
$ !
$ ! Get the system startup command procedure parameters.
$ !
$1000$:
$ ON WARNING THEN GOTO CLEANUP_AND_EXIT_WITH_STATUS
$ XXX = F$TRNLNM("EACF_SYS","LNM$SYSTEM_TABLE")
$ IF XXX .EQS. "" THEN XXX = "SYS$SYSDEVICE:[EACF]"
$ write sys$output "Note: Put Safety code somewhere other than sys$system if possible."
$ VMI$CALLBACK ASK GCY$SYS -
        "Enter directory for Safety programs" -
        "''XXX'" -
        DSZ ""
$ IF GCY$SYS .EQS. "^Z" THEN GOTO CLEANUP_AND_EXIT_WITH_FAILURE
$ DEFINE EACF_SYS 'GCY$SYS'
$ assign 'gcy$sys' gcy$sys:
$ assign/sys/exec 'gcy$sys' gcy$sys:
$ set noon
$ write sys$output "Creating directory if it does not exist"
$ crea/dir 'gcy$sys'
$ set on
$1010$:
$
$1020$:
$ ON WARNING THEN GOTO CLEANUP_AND_EXIT_WITH_STATUS
$ VMI$CALLBACK ASK GCY_GT_INTERNET -
        "Can this system send to and receive mail from the Internet" -
        "N" -
        DBZ ""
$ IF GCY_GT_INTERNET .EQS. "^Z" THEN GOTO CLEANUP_AND_EXIT_WITH_FAILURE
$ IF .NOT. GCY_GT_INTERNET THEN GOTO 1040$
$
$1030$:
$ ON WARNING THEN GOTO CLEANUP_AND_EXIT_WITH_STATUS
$ TYPE SYS$INPUT:
$ DECK

The Internet address for EACF Support is:

	support@GCE.Com

Please enter the VMSMail address necessary to reach support@GCE.MV.Com.
$ EOD
$ VMI$CALLBACK ASK GCY_GT_SUPPORT -
        "VMSMail address is" -
        "Support@GCE.Com" -
        DSZ ""
$ IF GCY_GT_SUPPORT .EQS. "^Z" THEN GOTO 1020$
$ xxx = GCY_GT_SUPPORT
$ gosub doubleQuote
$ GCY_GT_SUPPORT == yyy
$
$1040$:
$ !
$ ! Create the necessary directories.
$ !
$ !
$ ! Construct the system startup command procedure that defines the per system
$ ! environment.
$ !
$ ! Add all identifiers BEFORE files are delivered (which may need to have
$ ! acls set.)
$ !
$ ! Link the executable images.
$! (Note: this is for the VAX version and is done to simplify
$!  distribution for the moment.)
$oldloc=f$environment("default")
$set def vmi$kwd
$if f$getsyi("cpu") .lt. 128
$ then !vax
$set noon
$delete *.obj_a.
$! Use *.obj (vax/vms V6.1 compile) unless it looks like this VMS vers is V5
$delete *.obj_a*.
$delete *.exe_a*.
$set on
$if f$extract(1,3,f$getsyi("version")) .ges. "6.2"
$then
$ copy *.obj_vax62 *.obj
$ pur *.obj
$ del *.obj_vax62.
$endif
$if f$extract(1,1,f$getsyi("version")) .lts. "6"
$then
$! VMS V5.x
$! Get object files compiled under VMS 5.5-2 and use those.
$copy *.obj_vax5 *.obj
$pur *.obj
$endif
$if f$search("*.obj_vax5") .nes. "" then del *.obj_vax5.
$if f$search("*.obj_vax62") .nes. "" then del *.obj_vax62.
$link jtdolog
$link jtsavspc
$set noon
$write sys$output "Note: a `%LINK-W-USRTFR...` message is normal, not an err"
$link jtdriver+sys$system:sys.stb/sel+sys$input/opt
base=0
$set on
$link/notrace jtdmn+jtlic+jtopn+jtoprmsg+jttrnlnm+jtdeldo+jtgetmrk+jtlicace+-
 jted+jtspawn+jtsubprc1+jtsubprc2+jtsubprc3+sys$system:sys.stb/sel
$link jtrplace+jtmodace+jtauthm
$link/notrace jtdelmaint+jted+sys$system:sys.stb/sel
$link/notrace jtexfix+sys$system:sys.stb/sel
$link/notrace jtexset+jtoprmsg+jtemitlog+sys$system:sys.stb/sel
$link/notrace jtauthmaint+jtmodace+jtauthm+jtoprmsg+jted+sys$system:sys.stb/sel
$link/notrace jtexempt+jtemitlog+jtoprmsg+sys$system:sys.stb/sel
$link/notrace jtexedel+jtemitlog+jtoprmsg+sys$system:sys.stb/sel
$set noon
$rename jtfildel.com fildel.com
$copy jtfilsav.com filsav.com
$copy jtfilrst.com filrst.com
$copy jtfiltall.com filtall.com
$copy jtfilundel.com filundel.com
$copy jtmakspc.com makspc.com
$copy jtdel_shelved.com del_shelved.com
$else
$!AXP
$! we have *.obj_axp6 for VMS 6.x on AXP and *.obj_a for vms 7.x on AXP
$! except jtdriver_S264.obj_a is needed to be renamed to jtdriver.obj
$ vrs=f$getsyi("version")
$ if f$extract(0,1,vrs) .nes. "V" then vrs="V7.1"
$ if f$extract(1,1,vrs) .eqs. "6"
$then
$ del *.obj.
$ del *.obj_v*.
$ rename *.obj_axp6 *.obj
$copy zmenu.exe_Axp zmenu.exe_a
$copy zmenu_scroll.exe_axp zmenu_scroll.exe_a
$else
$! presume if not V6 it's V7
$ del *.obj.
$ rename *.obj_a *.obj
$ copy JTDRIVER_S264.OBJ jtdriver.obj
$ pur *.obj
$ VMI$CALLBACK ASK XV72 -
        "Is this VMS 7.2 or later [y/n]" -
        "N" -
        XV72 ""
$if XV72 .eqs. "Y" .or. XV72 .EQS. "y" 
$then
$! VMS 7.2 introduces PSB blocks so we need to use the code that
$! knows about them.
$ copy *.obj_axpvms72 *.obj
$ del *.obj_axpvms72.
$! Replace VESTed zmenu with native one.
$copy zmenu.exe_axp70 zmenu.exe_a
$copy zmenu.exe_axp70 zmenu.exe
$copy zmenu_scroll.exe_axp70 zmenu_scroll.exe_a
$pur
$!
$endif
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "No further questions will be asked."
$ WRITE SYS$OUTPUT ""
$endif
$ del *.exe.
$ rename *.exe_a *.exe
$rename jtfildel.com fildel.com
$link/notrace/sysexe=select jtexfix
$link/notrace/sysexe=select jtexset+jtoprmsg+jtemitlog
$copy jtfilsav.com filsav.com
$copy jtfilrst.com filrst.com
$copy jtfilundel.com filundel.com
$copy jtmakspc.com makspc.com
$copy jtfiltall.com filtall.com
$copy jtdel_shelved.com del_shelved.com
$link/notrace jtdolog
$link/notrace jtsavspc
$@jtdriverx.lnk
$link/notrace/nonative/sysexe=select jtdmn+jtlic+jtopn+jtoprmsg+jttrnlnm+jtdeldo+-
 jted+jtgetmrk+jtlicace+-
 jtspawn+jtsubprc1+jtsubprc2+jtsubprc3
$link/notrace jtrplace+jtmodace+jtauthm
$link/notrace/sysexe=select jtdelmaint+jted
$link/notrace/sysexe=select jtauthmaint+jtmodace+jtauthm+jtoprmsg+jted
$link/notrace/nonative/sysexe=select jtexempt+jtemitlog+jtoprmsg
$link/notrace/nonative/sysexe=select jtexedel+jtemitlog+jtoprmsg
$endif
$set def 'oldloc'
$ !
$ set on
$oldloc=f$environment("default")
$set def vmi$kwd
$copy zmenu.cld zmenu.cldx
$copy zmenu.exe zmenu.exex
$copy zmenu_scroll.exe zmenu_scroll.exex
$set def 'oldloc'
$ !
$ ! Set up access to the kit data files.
$ !
$VMI$CALLBACK PROVIDE_DCL_COMMAND JTDMN.CLD
$VMI$CALLBACK PROVIDE_DCL_COMMAND jtexfix.cld
$VMI$CALLBACK PROVIDE_DCL_COMMAND jtexset.cld
$VMI$CALLBACK PROVIDE_FILE EACF_FLSCLD JTDMN.cld "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSCLD "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLACLD jtexfix.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLACLD "[1,4]" "s:rwed,o:rwed,g:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLBCLD jtexset.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLBCLD "[1,4]" "s:rwed,o:rwed,g:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSCZ JTenter_passwords.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSCZ  "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSCL2 JTEXEMPT.cld "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSCL2 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSCL2 JTEXEDEL.cld "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSCL2 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSTY2 del_shelved.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSTY2 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEXE jtdmn.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSEXE "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FQSEXE jtsavspc.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FQSEXE "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEX2 jtauthmaint.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSEX2 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEX3 jtdolog.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSEX3 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSFX3 jtdelmaint.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSFX3 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEX4 jtexedel.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSEX4 "[1,4]" "s:rwed,o:rwed,g:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEX5 jtexempt.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSEX5 "[1,4]" "s:rwed,o:rwed,g:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEX6 jtrplace.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSEX6 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEY7 jtdelmaint.doc "sys$common:[sysmgr]"
$VMI$CALLBACK SECURE_FILE EACF_FLSEY7 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEF7 jtauthmaint.doc "sys$common:[sysmgr]"
$VMI$CALLBACK SECURE_FILE EACF_FLSEF7 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEX8 cswing.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSEX8 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEP1 file.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSEP1 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEP3 find.exe "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EACF_FLSEP3 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEP4 find.hlp "sys$common:[syshlp]"
$VMI$CALLBACK SECURE_FILE EACF_FLSEP4 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEP5 file.hlp "sys$common:[syshlp]"
$VMI$CALLBACK SECURE_FILE EACF_FLSEP5 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEP6 jtmark_files.com "sys$common:[sysmgr]"
$VMI$CALLBACK SECURE_FILE EACF_FLSEP6 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE HSM_FLSEP6 jtmove_files.com "sys$common:[sysmgr]"
$VMI$CALLBACK SECURE_FILE HSM_FLSEP6 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEP7 jt_sel_mark.com "sys$common:[sysmgr]"
$VMI$CALLBACK SECURE_FILE EACF_FLSEP7 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE HSM_FLSEP7 jt_sel_move.com "sys$common:[sysmgr]"
$VMI$CALLBACK SECURE_FILE HSM_FLSEP7 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEP8 jteacf.doc "sys$common:[syshlp]"
$VMI$CALLBACK SECURE_FILE EACF_FLSEP8 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSEP9 jt_setup.com "sys$common:[sysmgr]"
$VMI$CALLBACK SECURE_FILE EACF_FLSEP9 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE DPS_FLSEP9 jt_setup_del.com "sys$common:[sysmgr]"
$VMI$CALLBACK SECURE_FILE DPS_FLSEP9 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE DPS_FLSER9 jt_setup_eacf.com "sys$common:[sysmgr]"
$VMI$CALLBACK SECURE_FILE DPS_FLSER9 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE DPS_FLSES9 jt_setup_hsm.com "sys$common:[sysmgr]"
$VMI$CALLBACK SECURE_FILE DPS_FLSES9 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf1 fildel.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE cmf1 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf2 filrst.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf2 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf3 filsav.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf3 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cnf3 filtall.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cnf3 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf4 filundel.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf4 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf5 makspc.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf5 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf6 jtexpunge.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf6 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf7 jtpurge.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf7 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf8 jtundeluser.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf8 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FRDV JTDRIVER.EXE "sys$common:[sysexe]"
$VMI$CALLBACK SECURE_FILE EACF_FRDV "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EAF_ZMCL ZMENU.CLD  "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EAF_ZMCL  "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EAF_ZMEX ZMENU.EXE  "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EAF_ZMEX  "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EAF_ZMEX2 ZMENU_SCROLL.EXE  "gcy$sys:"
$VMI$CALLBACK SECURE_FILE EAF_ZMEX2  "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$VMI$CALLBACK PROVIDE_FILE EACF_FLSD EACF_USER_MAN.TXT "sys$help:"
$VMI$CALLBACK SECURE_FILE EACF_FLSD  "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file dmf2 JTfilrst.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  dmf2 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file dmf3 JTfilsav.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  dmf3 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf6 JTmakspc.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf6 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf7 JTfilsavmdsk.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf7 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf8 JTfilrstmdsk.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf8 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf9 JTspace_tailor.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf9 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf10 JT_softlink.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf10 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf11 JTrptspc.com "gcy$sys:"
$VMI$CALLBACK SECURE_FILE  cmf11 "[1,4]" "s:rwed,o:rwed,g:re,w:re"
$vmi$callback provide_file cmf12 JTcommand.doc sys$help:
$VMI$CALLBACK SECURE_FILE  cmf12 "[1,4]" "s:rwed,o:rwed,g:re"
$!
$oldloc=f$environment("default")
$set def vmi$kwd
$copy zmenu.cldx zmenu.cld
$copy zmenu.exex zmenu.exe
$copy zmenu_scroll.exex zmenu_scroll.exe
$copy zmenu.cld sys$common:[sysexe]
$copy zmenu.exe sys$common:[sysexe]
$copy zmenu_scroll.exe sys$common:[sysexe]
$set file/own=[1,4] sys$common:[sysexe]zm*.*
$set prot=(s:rwed,o:rwed,g:re,w:re) sys$common:[sysexe]zm*.*
$pur sys$common:[sysexe]zmenu*.*
$set def 'oldloc'
$ !
$ ! Install the product startup files and identify the startup command file for
$ ! IVP.
$ !
$INSTALL_STARTUP:
$ TYPE SYS$INPUT:
$ DECK

To complete the installation of the Extended Access Control Facility,
you must run the procedure SYS$MANAGER:JT_SETUP.COM (for a screen
oriented setup).

Then you must also modify the file SYS$MANAGER:SYSTARTUP_V5.COM
 or SYSTARTUP_VMS.COM to contain:

   $ IF F$SEARCH("SYS$MANAGER:SDH_STARTUP.COM") .NES. "" -
          THEN @SYS$MANAGER:SDH_STARTUP.COM

You should run the file GCY$SYS:JTSPACE_TAILOR.COM to set your site
policy on how to make space when the disk fills and space is being
monitored.
$ EOD
$ !
$ ! Move data files.
$ !
$MOVE_DATA:
$
$ !
$ ! Installation Complete.
$ !
$INSTALL_COMPLETE:
$
$ IF GCY_GT_INTERNET THEN CALL DIALHOME/OUTPUT=NL:
$ GOTO CLEANUP_AND_EXIT
$
$ !
$ ! Run the IVP, if one exists.
$ !
$IVP:
$
$ EXIT $STATUS

$CLEANUP_AND_EXIT_CONTROL_Y:
$ VMI$CALLBACK CONTROL_Y
$ STATUS = VMI$_FAILURE
$ GOTO CAE10$
$
$CLEANUP_AND_EXIT_WITH_STATUS:
$ STATUS = $STATUS
$ GOTO CAE10$
$
$CLEANUP_AND_EXIT_WITH_FAILURE:
$ STATUS = VMI$_FAILURE
$ GOTO CAE10$
$
$CLEANUP_AND_EXIT:
$ STATUS = VMI$_SUCCESS
$
$CAE10$:
$ EXIT STATUS

$ doubleQuote:
$ yyy = ""
$ i = f$locate("""",xxx)
$ 23016: if (.not.(i .ne. f$length(xxx))) then goto 23018
$ yyy = yyy + f$extract(0,i+1,xxx) + """"
$ xxx = f$extract(i+1,999,xxx)
$ 23017: i = f$locate("""",xxx)
$ goto 23016
$ 23018: 
$ yyy = yyy + xxx
$ return

$ dialhome: subroutine
$ set noon
$ define/user support "''GCY_GT_SUPPORT'"
$ mail/noself/subject="EACF installed at ''F$TIME()'" SYS$INPUT: support
$ deck
General Cybernetic Engineering EACF, DPS, etc. installed successfully.
$ eod
$ set on
$ exit
$ endsubroutine
