$set noverify
$! FilSav.com
$! Copyright (c) 1994 Glenn C. Everhart. All Rights Reserved.
$! Input:
$! @filsav dev:file.typ hexfid1 hexfid2
$! We shall presume the "file.typ" is actually a complete file spec
$! here. It is passed to filrst too, so we need only pick a unique
$! save name that can be restored & copy to delsav. Use backup to
$! do the copy so attrs & ownership can be preserved.
$! This command file will use file mod(filenumber/256),512) to
$! select a directory name to keep the file in the delsav: tree area
$! so that saved filescan be spread around the tree.
$ on warning then exit
$ delroot = f$trnlnm("DELSAV")
$ if delroot .eqs. "" then exit
$ delroot = delroot - "]"
$! Above assumes delsav is something like dev:[directory] and we
$! will want to turn it into dev:[directory.subdir]
$ file :==$gcy$sys:file
$ zip:==$gcy$sys:zip
$ unzip:==$gcy$sys:unzip
$ infil=p1
$ inhx1=p2
$ inhx2=p3
$ fncmd="$filenum = %x"+inhx1
$ 'fncmd'
$ filenum = filenum / 256
$ fnmsk=%x1ff
$ filenum = filenum .and. fnmsk
$ dvc=f$parse(infil,,,"device","syntax_only")
$ dvc=f$edit(dvc,"collapse,upcase")
$ delsub = dvc - ":" + f$string(filenum)
$! Be sure the subdirectory exists, and create it if it does not.
$ deltest = delroot + "]" + delsub + ".dir;1"
$ delroot = delroot + "." + delsub + "]"
$ if f$search(deltest) .eqs. "" then crea/dir 'delroot'
$! Now delroot is the directory where the file should go, named by device
$! and file number group. (This will also keep files apart by device nicely)
$ fnam=f$parse(infil,,,"name","syntax_only")+f$parse(infil,,,"type","syntax_only")
$ fnam=f$edit(fnam,"collapse,upcase")
$ if f$locate(".DIR;1",fnam) .lt. f$length(fnam) then exit 4
$ if f$length(fnam) .gt. 20 then fnam=f$extract(0,20,fnam)
$ ofilnm=delroot+inhx1+inhx2+fnam
$ ofzip=inhx1+inhx2+fnam-"."-";"
$ ofzip=f$extract(0,38,fnam)
$ ofzip=f$edit(ofilnm,"collapse,upcase")
$ ofilnm=f$edit(ofilnm,"collapse,upcase")
$ ! move the file
$ backup/trunc/ign=inter 'infil' 'ofilnm'/by_owner
$! If the user wants to store files compressed, let Zip compress them
$! at the save site.
$ curdef=f$environment("default")
$ if f$trnlnm("GCY$ZIPHSC") .eqs. "YES")
$ then
$  set def 'delroot'
$! Compress the file we moved to nearline. (Note that if nearline isn't
$! disk, we should compress & decompress in a scratch area. If backing
$! store is tape this would be so.)
$  ofzip=inhx1+inhx2+fnam-"."-";"
$  ofzip=f$extract(0,38,fnam)
$  ofzip=f$edit(ofilnm,"collapse,upcase")
$  zip "-9Vq" 'ofzip' 'ofilnm'
$  delete 'ofilnm'.
$  set def 'curdef'
$ endif
$ ! now truncate the original
$ osiz=f$file_attributes(infil,"eof")
$ file/end=1/first_free=0 'infil'
$ set file/trunc/nobackup 'infil'
$ file/end='osiz'/first_free=510 'infil'
$! Above leaves original file truncated but leaves EOF mark at the original
$! location.
$ logo
