$! make space on a device.
$! @makspc device nblks
$! free up nblks space on device.
$! Note this one just selects. A sorting pass to record size and/or date
$! and sort on those to get oldest/biggest first needs to be added
$! though this version is usable.
$! We use two methods:
$! 1. Purge the delete wastebasket of files deleted "long enough" ago, and
$!	stop if enough space is freed.
$! 2. Shelve files until enough space is freed (or nothing else eligible for
$!	shelving can be found.
$!
$! Default for purging deleted files is things deleted over an hour ago
$! get deleted finally.
$!
$dvc=p1
$nblks=p2
$if dvc .eqs. "" then goto done
$if nblks .le. 0 then goto done
$find:==$gcy$sys:find
$! It is expected the selections will be set up per system and per
$! server by a script.
$! We can switch between devices here if we need to, but should do the best
$! we can on selection.
$if f$trnlnm("gcy$scratch") .eqs. "" then ass sys$scratch: gcy$scratch:
$if f$search("gcy$scratch:mksin.dat") .nes. "" then delete gcy$scratch:mksin.dat.
$! Do not alter the following line
$! Set fdefault minimum size to move and minimum age to move here.
$dayago=2
$oldday="yesterday"
$minal=10
$secondsago=3600
$! start with 1 hour ago deletions
$! Reset "dayago" or "minal" below
$!+++$$$===
$!
$ inispc=f$getdvi(dvc,"FREEBLOCKS")
$if secondsago .gt.0
$ then
$! First get rid of files deleted over an hour ago.
$! If this is tailored so "secondsago" becomes some other interval
$! then get rid of stuff deleted before then.
$ jtdelmaint:==$gcy$sys:jtdelmaint
$ jtdelmaint sys$sysdevice/PURGE:'secondsago'
$ needspc=inispc + nblks
$ spcnow=f$getdvi(dvc,"FREEBLOCKS")
$ ! If enough space is freed, no need to shelve anything.
$ if spcnow .gt. needspc then exit 1
$ endif
$! Stop after purge of deleted files if the age threshold is over 9999 days.
$ If dayago .gt. 9999 then exit 1
$today=f$time()
$day=f$integer(f$cvt(today,,"day"))
$mon=f$integer(f$cvt(today,,"month"))
$yr=f$integer(f$cvt(today,,"year"))
$day = day - dayago
$daylp:
$if (day .lt. 1)
$ then
$ ! compute date some number of days ago. Go back a month at a time
$ ! if this is more than just a few days.
$ dpm=31
$ yrd=0
$ if mon .eq. 1 then yrd = -1
$ if mon .eq. 3 then dpm = 28
$ if mon .eq. 5 then dpm = 30
$ if mon .eq. 7 then dpm = 30
$ if mon .eq. 12 then dpm = 30
$ day = day + dpm
$ mon = mon -1
$ if mon .lt. 1 
$ then
$ mon=12
$ yr = yr -1
$ endif
$! Date could be a couple months, so keep trying if one is not enough.
$! Note we're sloppy about leap years here.
$ dayago = dayago - dpm
$ if dayago .gt. 0 then goto daylp
$ endif
$ mstr="Jan"
$ if mon .eq. 2 then mstr="Feb"
$ if mon .eq. 3 then mstr="Mar"
$ if mon .eq. 4 then mstr="Apr"
$ if mon .eq. 5 then mstr="May"
$ if mon .eq. 6 then mstr="Jun"
$ if mon .eq. 7 then mstr="Jul"
$ if mon .eq. 8 then mstr="Aug"
$ if mon .eq. 9 then mstr="Sep"
$ if mon .eq. 10 then mstr="Oct"
$ if mon .eq. 11 then mstr="Nov"
$ if mon .eq. 12 then mstr="Dec"
$ oldday=" "
$oldday=f$string(day)+"-"+mstr+"-"+f$string(yr)
$find/char=(nocontig,nodirec,backup)/alloc=('minal',250000)/org=noindexed-
/out=gcy$scratch:mksin.dat/crea=(17-nov-1858,'oldday')/match=AND-
/revision=(17-nov-1858,'oldday')/expir=(17-nov-1858,'oldday') 'dvc'
$! This gets a list of files. Now edit it to a list we can USE by
$! eliminating any files of with SYS in the path or with ? in the
$! path.
$if f$file_attributes("gcy$scratch:mksin.dat","eof") .lt. 1 then exit 1
$open/read ifil gcy$scratch:mksin.dat
$if f$search("gcy$scratch:min.dat") .nes. "" then delete gcy$scratch:min.dat.
$open/write ofil gcy$scratch:min.dat
$vlin=" "
$editloop:
$read/end=editend/err=editend ifil vlin
$if f$locate("?",vlin) .lt. f$length(vlin) then goto editloop
$if f$locate(":",vlin) .ge. f$length(vlin) then goto editloop
$if f$locate("SYS",vlin) .lt. f$length(vlin) then goto editloop
$if f$locate("VMS$CO",vlin) .lt. f$length(vlin) then goto editloop
$! Don't try to swap virtual disks either
$if f$locate("DSK",vlin) .lt. f$length(vlin) then goto editloop
$! check for installed file
$if f$file_attributes(vlin,"KNOWN") .eqs. "TRUE" then goto editloop
$if f$file_attributes(vlin,"STORED_SEMANTICS") .nes. "" then goto editloop
$if f$file_attributes(vlin,"NOBACKUP") .eqs. "TRUE" THEN GOTO EDITLOOP
$! directories are contiguous so this omits them.
$if f$file_attributes(vlin,"CTG") .eqs. "TRUE" THEN GOTO EDITLOOP
$if f$file_attributes(vlin,"ORG") .EQS. "IDX" THEN GOTO EDITLOOP
$set noon
$! following tests will fail before vms v6, but are useful after.
$! Thus we tell DCL to ignore errors on these tests.
$if f$file(vlin,"MOVE") .eqs. "FALSE" then goto editloop
$if f$file(vlin,"SHELVABLE") .EQS. "FALSE" then goto editloop
$set on
$! Following line is a marker...don't mess with it.
$! Add checks on filenames below
$!+++@@@===
$!
$write ofil vlin
$goto editloop
$editend:
$close ifil
$close ofil
$! 
$! Now mark files for move till we have enough space.
$!inispc=f$getdvi(dvc,"FREEBLOCKS")
$needspc=inispc + nblks
$jtauthmaint:==$gcy$sys:jtauthmaint
$open ofil gcy$scratch:min.dat
$spclop:
$read/end=endspc/err=endspc ofil vlin
$jtauthmaint 'vlin'\I+H+M+X+U*<*>K*<*>N*<*>T<YYYYYYYYYYYYYYYYYYYYYYYY>V<FFFFFFFFFFFFFFFF>
$spcnow=f$getdvi(dvc,"FREEBLOCKS")
$! Stop migrating files when we have freed enough room.
$if spcnow .lt. needspc then goto spclop
$endspc:
$close ofil
$done:
$exit 1
